//+------------------------------------------------------------------+
//|                                              MetaTraderAgent.mq4 |
//|                                                               ZZ |
//|                                                        http://zz |
//+------------------------------------------------------------------+
#property copyright "fx-at.net"
#property link      "http://fx-at.net"

#include "MetaTraderSocket.mqh"


//Socket API for MetaTrader 4 - MT4 that allows establish communication
//between MT4 and other trading platform (like other MT4, Dukascopy, MBTrading)
//By using this library in your EA you can build bridge between different kind of trading platforms
//Visit http://fx-at.net for instruction how to use this code

//There is no warranty for this free software.
//THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
//OR IMPLIED. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.


string HOST = "127.0.0.1";
int PORT = 7788;

int STOP_LOSS = 20;
int TAKE_PROFIT = 20;
double VOLUME = 0.1;


//+------------------------------------------------------------------+
//| script main function                                            |
//+------------------------------------------------------------------+
int start()
{
   Print("MetaTraderSocket started! http://fx-at.net");
   int serverSocket = server_init(HOST, PORT);
   Print("Server socked #" + serverSocket + " host " + HOST + ":" + PORT +" is opened");
   if(serverSocket == 0) {
      Print("Server socked #" + serverSocket + " host " + HOST + ":" + PORT +" cannot be opened due to error.");
      return(0);
   }
   
   string message = "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
   
   while(StringGetChar(message,0) != '@') {
      int clientSocket = server_accept_connection(serverSocket);
      Print("Client connected #" + clientSocket + " message=" + message);
      
      if(clientSocket < 1) {
        Print("Error during client connect #" + clientSocket);
        break;
      }
      
      int internalLoopFlag = 0;
      
      while(StringGetChar(message,0) != '@') {
         internalLoopFlag = 1;
         server_read_socket(clientSocket, message);
         Print("Received message = " + message);
         
         //Parse message
         int p1 = StringFind(message,";",0);
         int p2 = StringFind(message,";",p1 + 1);
         int p3 = StringFind(message,";",p2 + 1);
         int p4 = StringFind(message,";",p3 + 1);
         
         if(p1 < 0 || p2 < 0 || p3 < 0 || p4 <0) {
            Print("Incorrect message = " + message);
            internalLoopFlag = 0;
            break;
         }
         
         string msgBroker = StringSubstr(message, 0, p1);
         string msgSymbol = StringSubstr(message, p1 + 1, p2 - p1 - 1);
         string msgBid = StringSubstr(message, p2 + 1, p3 - p2 - 1); 
         string msgAsk = StringSubstr(message, p3 + 1, p4 - p3 - 1); 
         string msgCommand = StringSubstr(message, p4 + 1, StringLen(message) - p4);
       
         //Print("Received parsed message: msgBroker=" + msgBroker + "; msgSymbol=" + msgSymbol + "; msgBid=" + msgBid +
         //   "; msgAsk=" + msgAsk + "; msgCommand=" + msgCommand);
           
         //Take symbol parameters
         double point1 =MarketInfo(msgSymbol,MODE_POINT);
         int digits1 = MarketInfo(msgSymbol, MODE_DIGITS);
         int ticket = -1;
         //Execute order BUY
         if(msgCommand == "B") {
            double buyPrice = NormalizeDouble(StrToDouble(msgAsk), digits1);
            ticket = OrderSend(msgSymbol, OP_BUY, VOLUME,  buyPrice,0,NormalizeDouble(buyPrice - STOP_LOSS*point1, digits1) ,NormalizeDouble(buyPrice + TAKE_PROFIT*point1, digits1) ,"autobuy");
            if(ticket < 0) {
                Print("OrderSend OP_BUY failed with error #",GetLastError());
            }
         }
         //Execute order SELL
         if(msgCommand == "B") {
            double sellPrice = NormalizeDouble(StrToDouble(msgBid), digits1);
            ticket = OrderSend("EURUSD",OP_SELL, VOLUME,sellPrice,0, NormalizeDouble(sellPrice + STOP_LOSS*point1, digits1) ,NormalizeDouble(sellPrice - TAKE_PROFIT*point1, digits1) ,"autosell");
            if(ticket < 0) {
                Print("OrderSend OP_BUY failed with error #",GetLastError());
            }
         }
         

      }
      
      if(internalLoopFlag < 1) {
        break;
      }
      

      
   } //while( msg(0) != '@' )
   server_socket_close(clientSocket);
   server_socket_close_cleanup(serverSocket);
   Print("MetaTraderSocket stop! http://fx-at.net");
   return(0);
}

